Layout
Elementary

## Macros

#define | elm_layout_icon_set(_ly, _obj)
| Convenience macro to set the icon object in a layout that follows the Elementary naming convention for its parts.
#define | elm_layout_icon_get(_ly)
| Convenience macro to get the icon object from a layout that follows the Elementary naming convention for its parts.
#define | elm_layout_end_set(_ly, _obj)
| Convenience macro to set the end object in a layout that follows the Elementary naming convention for its parts.
#define | elm_layout_end_get(_ly)
| Convenience macro to get the end object in a layout that follows the Elementary naming convention for its parts.

## Functions

Evas_Object * | elm_layout_add (Evas_Object *parent)
| Add a new layout to the parent.
Eina_Bool | elm_layout_theme_set (Evas_Object *obj, const char *klass, const char *group, const char *style)
| Set the edje group from the elementary theme that will be used as layout.
void | elm_layout_sizing_eval (Evas_Object *obj)
| Eval sizing.
void | elm_layout_sizing_restricted_eval (Evas_Object *obj, Eina_Bool width, Eina_Bool height)
| Request sizing reevaluation, restricted to current width and/or height.
void | elm_layout_signal_callback_add (Evas_Object *obj, const char *emission, const char *source, Edje_Signal_Cb func, void *data)
| Add a callback for a (Edje) signal emitted by a layout widget's underlying Edje object.
void * | elm_layout_signal_callback_del (Evas_Object *obj, const char *emission, const char *source, Edje_Signal_Cb func)
| Remove a signal-triggered callback from a given layout widget.
void | elm_layout_signal_emit (Evas_Object *obj, const char *emission, const char *source)
| Send a (Edje) signal to a given layout widget's underlying Edje object.
Efl_Canvas_Object * | elm_layout_edje_get (const Evas_Object *obj)
| Get the edje layout.
Eina_List * | elm_layout_content_swallow_list_get (const Evas_Object *obj)
| Get the list of swallow parts of a given container widget.
Eina_Bool | elm_layout_content_set (Evas_Object *obj, const char *swallow, Evas_Object *content)
| Set the layout content.
Evas_Object * | elm_layout_content_get (const Evas_Object *obj, const char *swallow)
| Get the child object in the given content part.
Evas_Object * | elm_layout_content_unset (Evas_Object *obj, const char *swallow)
| Unset the layout content.
Eina_Bool | elm_layout_file_set (Eo *obj, const char *file, const char *group)
| Set the file that will be used as layout.
void | elm_layout_file_get (Eo *obj, const char **file, const char **group)
| Get the loaded file.
Eina_Bool | elm_layout_mmap_set (Eo *obj, const Eina_File *file, const char *group)
| Set the mmap file that will be used as layout.
void | elm_layout_mmap_get (Eo *obj, const Eina_File **file, const char **group)
| Get the loaded mmap file.
Eina_Bool | elm_layout_box_append (Evas_Object *obj, const char *part, Evas_Object *child)
| Append child to layout box part.
Eina_Bool | elm_layout_box_prepend (Evas_Object *obj, const char *part, Evas_Object *child)
| Prepend child to layout box part.
Eina_Bool | elm_layout_box_insert_before (Evas_Object *obj, const char *part, Evas_Object *child, const Evas_Object *reference)
| Insert child to layout box part before a reference object.
Eina_Bool | elm_layout_box_insert_at (Evas_Object *obj, const char *part, Evas_Object *child, unsigned int pos)
| Insert child to layout box part at a given position.
Evas_Object * | elm_layout_box_remove (Evas_Object *obj, const char *part, Evas_Object *child)
| Remove a child of the given part box.
Eina_Bool | elm_layout_box_remove_all (Evas_Object *obj, const char *part, Eina_Bool clear)
| Remove all children of the given part box.
Eina_Bool | elm_layout_table_pack (Evas_Object *obj, const char *part, Evas_Object *child, unsigned short col, unsigned short row, unsigned short colspan, unsigned short rowspan)
| Insert child to layout table part.
Evas_Object * | elm_layout_table_unpack (Evas_Object *obj, const char *part, Evas_Object *child)
| Unpack (remove) a child of the given part table.
Eina_Bool | elm_layout_table_clear (Evas_Object *obj, const char *part, Eina_Bool clear)
| Remove all the child objects of the given part table.
const char * | elm_layout_data_get (const Evas_Object *obj, const char *key)
| Get the edje data from the given layout.
int | elm_layout_freeze (Evas_Object *obj)
| Freezes the Elementary layout object.
int | elm_layout_thaw (Evas_Object *obj)
| Thaws the Elementary object.
Eina_Bool | elm_layout_text_set (Evas_Object *obj, const char *part, const char *text)
| Set the text of the given part.
const char * | elm_layout_text_get (const Evas_Object *obj, const char *part)
| Get the text set in the given part.
Eina_Bool | elm_layout_edje_object_can_access_set (Evas_Object *obj, Eina_Bool can_access)
| Set accessibility to all texblock(text) parts in the layout object.
Eina_Bool | elm_layout_edje_object_can_access_get (const Evas_Object *obj)
| Get accessibility state of texblock(text) parts in the layout object.
Eina_Bool | elm_layout_part_cursor_engine_only_set (Evas_Object *obj, const char *part_name, Eina_Bool engine_only)
| Sets if the cursor set should be searched on the theme or should use the provided by the engine, only.
Eina_Bool | elm_layout_part_cursor_engine_only_get (const Evas_Object *obj, const char *part_name)
| Get a specific cursor engine_only for an edje part.
Eina_Bool | elm_layout_part_cursor_set (Evas_Object *obj, const char *part_name, const char *cursor)
| Sets a specific cursor for an edje part.
const char * | elm_layout_part_cursor_get (const Evas_Object *obj, const char *part_name)
| Get the cursor to be shown when mouse is over an edje part.
Eina_Bool | elm_layout_part_cursor_style_set (Evas_Object *obj, const char *part_name, const char *style)
| Sets a specific cursor style for an edje part.
const char * | elm_layout_part_cursor_style_get (const Evas_Object *obj, const char *part_name)
| Get a specific cursor style for an edje part.
Eina_Bool | elm_layout_part_cursor_unset (Evas_Object *obj, const char *part_name)
| Unsets a cursor previously set with elm_layout_part_cursor_set.

## Detailed Description

A Layout is a direct realization of The Elementary Layout Class.

This is a container widget that takes a standard Edje design file and wraps it very thinly in a widget.

An Edje design (theme) file has a very wide range of possibilities to describe the behavior of elements forming a layout. Check out the Edje documentation and the EDC reference to get more information about what can be done with Edje.

Just like Elm_List, Elm_Box, and other container widgets, any object added to the Layout will become its child, meaning that it will be deleted if the Layout is deleted, moved if the Layout is moved, and so on.

The layout widget may contain as many parts/children as described in its theme file. Some of these children can have special types, such as content holder ones (swallow spots), boxes or tables. These are parts meant to contain others. For instance, objects can be added to different table parts by specifying the respective table part names. The same is valid for swallows and boxes.

The objects added as children of a layout will behave as described in the part description where they were added. There are 3 possible types of parts where a child can be added:

# Content (`SWALLOW` part)

Only one object can be added to the `SWALLOW` part at a time (but you still can have many `SWALLOW` parts and one object on each of them). Use the `elm_layout_content_set()/get/unset` functions to set, retrieve and unset objects as content of the `SWALLOW`. After being set to this part, the object's size, position, visibility, clipping and other description properties will be totally controlled by the description of the given part (inside the Edje theme file).

One can use `evas_object_size_hint_*` functions on the child to have some kind of control over its behavior, but the resulting behavior will still depend heavily on the `SWALLOW` part's description.

The Edje theme also can change the part description, based on signals or scripts running inside the theme. This change can also be animated. All of this will affect the child object set as content accordingly. The object's size will be changed if the part size is changed, it will animate moving accordingly if the part is moving, and so on.

The following picture demonstrates a layout widget with a child object added to its `SWALLOW:`

# Box (`BOX` part)

An Edje `BOX` part is very similar to the Elementary Elm_Box widget. It allows one to add objects to the box and have them distributed along its area, accordingly to the specified `layout` property (now by `layout` we mean the chosen layouting design of the Box, not the layout widget itself).

A similar effect for having a box with its position, size and other things controlled by the layout theme would be to create an Elementary Elm_Box widget and add it as content in a `SWALLOW` part.

The main difference to that, by using the layout box instead, is that its behavior, like layouting format, padding, align, etc., will all be controlled by the theme. This means, for example, that a signal could be sent to the layout's theme (with elm_layout_signal_emit()) and the signal be handled by changing the box's padding, or alignment, or both. Using the Elementary Elm_Box widget is not necessarily harder or easier, it just depends on the circumstances and requirements.

The layout box can be used through the `elm_layout_box_*` set of functions.

The following picture demonstrates a Layout widget with many child objects added to its `BOX` part:

# Table (`TABLE` part)

Just like the Box (`BOX` part), the layout table is very similar to the Elementary Elm_Table widget. It allows one to add objects to the table by specifying the row and column where the object should be added, and any column or row span, if necessary.

Again, we could have this design by adding a Elm_Table widget to a `SWALLOW` part, using elm_layout_content_set(). The same difference happens here when choosing to use the layout table (a `TABLE` part) instead of the Elm_Table in a `SWALLOW` part. It's just a matter of convenience.

The layout table can be used through the `elm_layout_table_*` set of functions.

The following picture demonstrates a layout widget with many child objects added to its `TABLE` part:

# Predefined Layouts

Another interesting thing about the layout widget is that it offers some predefined themes that come with the default Elementary theme. These themes can be set by the call elm_layout_theme_set(), and provide some basic functionality depending on the theme used.

Most of them already send some signals, some already provide a toolbar or back and next buttons.

These are the available predefined theme layouts. All of them have class = `layout`, group = `application`, and style = one of the following options:

- `toolbar-content` - for applications with a toolbar and main content area
- `toolbar-content-back` - for applications with a toolbar and main content (with a back button) and title areas
- `toolbar-content-back-next` - for applications with a toolbar and main content (with back and next buttons) and title areas
- `content-back` - for application with main content (with a back button) and title areas
- `content-back-next` - for applications with main content (with back and next buttons) and title areas
- `toolbar-vbox` - for applications with a toolbar and main content area as a vertical box
- `toolbar-table` - for applications with a toolbar and main content area as a table

# Emitted signals

This widget emits the following signals:

- "theme,changed" - The theme was changed.
- "language,changed" - the program's language changed

# Examples

Some examples of the Layout widget can be found here:

- Layout - Content, Table and Box
- Layout - Predefined Layout
- Layout - Signals and Size Changed
- An example of layout theme file

## Macro Definition Documentation

## elm_layout_icon_set

#define elm_layout_icon_set | ( |  | _ly,
|  |  | _obj )

Value:
do { \
const char *sig; \
elm_layout_content_set((_ly), "elm.swallow.icon", (_obj)); \
if ((_obj)) sig = "elm,state,icon,visible"; \
else sig = "elm,state,icon,hidden"; \
elm_layout_signal_emit((_ly), sig, "elm"); \
} while (0)

Convenience macro to set the icon object in a layout that follows the Elementary naming convention for its parts.

## elm_layout_icon_get

#define elm_layout_icon_get | ( |  | _ly | ) |

Value:
elm_layout_content_get((_ly), "elm.swallow.icon")
elm_layout_content_get
Evas_Object * elm_layout_content_get(const Evas_Object *obj, const char *swallow)
Get the child object in the given content part.
Definition efl_ui_layout.c:1281

Convenience macro to get the icon object from a layout that follows the Elementary naming convention for its parts.

## elm_layout_end_set

#define elm_layout_end_set | ( |  | _ly,
|  |  | _obj )

Value:
do { \
const char *sig; \
elm_layout_content_set((_ly), "elm.swallow.end", (_obj)); \
if ((_obj)) sig = "elm,state,end,visible"; \
else sig = "elm,state,end,hidden"; \
elm_layout_signal_emit((_ly), sig, "elm"); \
} while (0)

Convenience macro to set the end object in a layout that follows the Elementary naming convention for its parts.

## elm_layout_end_get

#define elm_layout_end_get | ( |  | _ly | ) |

Value:
elm_layout_content_get((_ly), "elm.swallow.end")

Convenience macro to get the end object in a layout that follows the Elementary naming convention for its parts.

## Function Documentation

## elm_layout_add()

Evas_Object * elm_layout_add | ( | Evas_Object * | parent | ) |

Add a new layout to the parent.

Parameters

  parent | The parent object

Returns
  The new object or NULL if it cannot be created

See also
  elm_layout_file_set()
  elm_layout_theme_set()

References EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by elm_color_class_editor_add().

## elm_layout_theme_set()

Eina_Bool elm_layout_theme_set | ( | Evas_Object * | obj,
|  | const char * | klass,
|  | const char * | group,
|  | const char * | style )

Set the edje group from the elementary theme that will be used as layout.

Note that `style` will be the new style of `obj` too, as in an elm_object_style_set call.

Parameters

  [in] | klass | The class of the group.
  [in] | group | The group.
  [in] | style | The style to used.

Returns
  `true` on success, `false` otherwise

Referenced by elm_color_class_editor_add().

## elm_layout_sizing_eval()

void elm_layout_sizing_eval | ( | Evas_Object * | obj | ) |

Eval sizing.

Manually forces a sizing re-evaluation. This is useful when the minimum size required by the edje theme of this layout has changed. The change on the minimum size required by the edje theme is not immediately reported to the elementary layout, so one needs to call this function in order to tell the widget (layout) that it needs to reevaluate its own size.

The minimum size of the theme is calculated based on minimum size of parts, the size of elements inside containers like box and table, etc. All of this can change due to state changes, and that's when this function should be called.

Also note that a standard signal of "size,eval" "elm" emitted from the edje object will cause this to happen too.

Examples
  codegen_example.c, and layout_example_03.c.

## elm_layout_sizing_restricted_eval()

void elm_layout_sizing_restricted_eval | ( | Evas_Object * | obj,
|  | Eina_Bool | width,
|  | Eina_Bool | height )

Request sizing reevaluation, restricted to current width and/or height.

Useful mostly when there are TEXTBLOCK parts defining the height of the object and nothing else restricting it to a minimum width. Calling this function will restrict the minimum size in the Edje calculation to whatever size it the layout has at the moment.

Parameters

  [in] | width | Restrict minimum size to the current width.
  [in] | height | Restrict minimum size ot the current height.

Since
  1.8

References EINA_SAFETY_ON_NULL_RETURN, _Elm_Layout_Data::restricted_calc_h, and _Elm_Layout_Data::restricted_calc_w.

## elm_layout_signal_callback_add()

void elm_layout_signal_callback_add | ( | Evas_Object * | obj,
|  | const char * | emission,
|  | const char * | source,
|  | Edje_Signal_Cb | func,
|  | void * | data )

Add a callback for a (Edje) signal emitted by a layout widget's underlying Edje object.

This function connects a callback function to a signal emitted by the underlying Edje object of `obj`. Globs are accepted in either the emission or source strings.

Parameters

  [in] | emission | The signal's name string.
  [in] | source | The signal's source string.
  [in] | func | The callback function to be executed when the signal is emitted.
  [in] | data | A pointer to data to pass in to the callback function.

References _Efl_Ui_Layout_Data::edje_signals, ELM_ENTRY_CLASS, and _Elm_Widget_Smart_Data::resize_obj.

Referenced by elm_color_class_editor_add().

## elm_layout_signal_callback_del()

void * elm_layout_signal_callback_del | ( | Evas_Object * | obj,
|  | const char * | emission,
|  | const char * | source,
|  | Edje_Signal_Cb | func )

Remove a signal-triggered callback from a given layout widget.

This function removes the last callback attached to a signal emitted by the underlying Edje object of `obj`, with parameters `emission`, `source` and `func` matching exactly those passed to a previous call to elm_layout_signal_callback_add. The data pointer that was passed to this call will be returned.

Parameters

  [in] | emission | The signal's name string.
  [in] | source | The signal's source string.
  [in] | func | The callback function being executed when the signal was emitted.

Returns
  The data pointer of the signal callback (passed on elm_layout_signal_callback_add) or `null` on errors.

References _Efl_Ui_Layout_Data::edje_signals, ELM_ENTRY_CLASS, and _Elm_Widget_Smart_Data::resize_obj.

## elm_layout_signal_emit()

void elm_layout_signal_emit | ( | Evas_Object * | obj,
|  | const char * | emission,
|  | const char * | source )

Send a (Edje) signal to a given layout widget's underlying Edje object.

This function sends a signal to the underlying Edje object of `obj`. An Edje program on that Edje object's definition can respond to a signal by specifying matching 'signal' and 'source' fields.

Parameters

  [in] | emission | The signal's name string.
  [in] | source | The signal's source string.

Referenced by elm_slider_indicator_show_set().

## elm_layout_edje_get()

Efl_Canvas_Object * elm_layout_edje_get | ( | const Evas_Object * | obj | ) |

Get the edje layout.

This returns the edje object. It is not expected to be used to then swallow objects via edje_object_part_swallow for example. Use elm_layout_content_set instead so child object handling and sizing is done properly.

Note
  This function should only be used if you really need to call some low level Edje function on this edje object. All the common stuff (setting text, emitting signals, hooking callbacks to signals, etc.) can be done with proper elementary functions.

Returns
  An Evas_Object with the edje layout settings loaded elm_layout_file_set.

References EINA_SAFETY_ON_FALSE_RETURN_VAL, and _Elm_Widget_Smart_Data::resize_obj.

Referenced by elm_scroller_propagate_events_get(), and elm_scroller_propagate_events_set().

## elm_layout_content_swallow_list_get()

Eina_List * elm_layout_content_swallow_list_get | ( | const Evas_Object * | obj | ) |

Get the list of swallow parts of a given container widget.

Parameters

  obj | The layout object

Returns
  list of swallow parts which should be freed by the user program with elm_list_free()

Since
  1.9

References eina_list_append(), EINA_LIST_FOREACH, and _Efl_Ui_Layout_Data::subs.

## elm_layout_content_set()

Eina_Bool elm_layout_content_set | ( | Evas_Object * | obj,
|  | const char * | swallow,
|  | Evas_Object * | content )

Set the layout content.

Parameters

  obj | The layout object
  swallow | The swallow part name in the edje file
  content | The child that will be added in this layout object

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

Once the content object is set, a previously set one will be deleted. If you want to keep that old content object, use the elm_layout_content_unset() function.

Note
  In an Edje theme, the part used as a content container is called `SWALLOW`. This is why the parameter name is called `swallow`, but it is expected to be a part name just like the second parameter of elm_layout_box_append().

See also
  elm_layout_box_append()
  elm_layout_content_get()
  elm_layout_content_unset()
  Box (`BOX` part)

References EINA_FALSE.

## elm_layout_content_get()

Evas_Object * elm_layout_content_get | ( | const Evas_Object * | obj,
|  | const char * | swallow )

Get the child object in the given content part.

Parameters

  obj | The layout object
  swallow | The SWALLOW part to get its content

Returns
  The swallowed object or NULL if none or an error occurred

References EINA_FALSE.

## elm_layout_content_unset()

Evas_Object * elm_layout_content_unset | ( | Evas_Object * | obj,
|  | const char * | swallow )

Unset the layout content.

Parameters

  obj | The layout object
  swallow | The swallow part name in the edje file

Returns
  The content that was being used

Unparent and return the content object which was set for this part.

References EINA_FALSE.

## elm_layout_file_set()

Eina_Bool elm_layout_file_set | ( | Eo * | obj,
|  | const char * | file,
|  | const char * | group )

Set the file that will be used as layout.

Returns
  (1 = success, 0 = error)

Parameters

  [in] | file | The path to file (edj) that will be used as layout
  [in] | group | The group that the layout belongs in edje file

## elm_layout_file_get()

void elm_layout_file_get | ( | Eo * | obj,
|  | const char ** | file,
|  | const char ** | group )

Get the loaded file.

Parameters

  file | The path to file (edj) used as layout
  group | The group that the layout belongs in edje file

Since
  1.14

## elm_layout_mmap_set()

Eina_Bool elm_layout_mmap_set | ( | Eo * | obj,
|  | const Eina_File * | file,
|  | const char * | group )

Set the mmap file that will be used as layout.

Returns
  (1 = success, 0 = error)

Parameters

  [in] | file | Eina_File (edj) that will be used as layout
  [in] | group | The group that the layout belongs in edje file

Since
  1.19

## elm_layout_mmap_get()

void elm_layout_mmap_get | ( | Eo * | obj,
|  | const Eina_File ** | file,
|  | const char ** | group )

Get the loaded mmap file.

Parameters

  file | Eina_File (edj) used as layout
  group | The group that the layout belongs in edje file

Since
  1.19

## elm_layout_box_append()

Eina_Bool elm_layout_box_append | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child )

Append child to layout box part.

Once the object is appended, it will become child of the layout. Its lifetime will be bound to the layout, whenever the layout dies the child will be deleted automatically. One should use elm_layout_box_remove to make this layout forget about the object.

Parameters

  [in] | child | The child object to append to box.

## elm_layout_box_prepend()

Eina_Bool elm_layout_box_prepend | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child )

Prepend child to layout box part.

Once the object is prepended, it will become child of the layout. Its lifetime will be bound to the layout, whenever the layout dies the child will be deleted automatically. One should use elm_layout_box_remove to make this layout forget about the object.

Parameters

  [in] | child | The child object to prepend to box.

## elm_layout_box_insert_before()

Eina_Bool elm_layout_box_insert_before | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child,
|  | const Evas_Object * | reference )

Insert child to layout box part before a reference object.

Once the object is inserted, it will become child of the layout. Its lifetime will be bound to the layout, whenever the layout dies the child will be deleted automatically. One should use elm_layout_box_remove to make this layout forget about the object.

Parameters

  [in] | child | The child object to insert into box.
  [in] | reference | Another reference object to insert before in box.

## elm_layout_box_insert_at()

Eina_Bool elm_layout_box_insert_at | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child,
|  | unsigned int | pos )

Insert child to layout box part at a given position.

Once the object is inserted, it will become child of the layout. Its lifetime will be bound to the layout, whenever the layout dies the child will be deleted automatically. One should use elm_layout_box_remove to make this layout forget about the object.

Parameters

  [in] | child | The child object to insert into box.
  [in] | pos | The numeric position >=0 to insert the child.

## elm_layout_box_remove()

Evas_Object * elm_layout_box_remove | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child )

Remove a child of the given part box.

The object will be removed from the box part and its lifetime will not be handled by the layout anymore. This is equivalent to elm_layout_content_unset for box.

Parameters

  [in] | child | The object to remove from box.

Returns
  The object that was being used, or `null` if not found.

## elm_layout_box_remove_all()

Eina_Bool elm_layout_box_remove_all | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | clear )

Remove all children of the given part box.

The objects will be removed from the box part and their lifetime will not be handled by the layout anymore. This is equivalent to elm_layout_box_remove for all box children.

Parameters

  [in] | clear | If true, then all objects will be deleted as well, otherwise they will just be removed and will be dangling on the canvas.

## elm_layout_table_pack()

Eina_Bool elm_layout_table_pack | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child,
|  | unsigned short | col,
|  | unsigned short | row,
|  | unsigned short | colspan,
|  | unsigned short | rowspan )

Insert child to layout table part.

Once the object is inserted, it will become child of the table. Its lifetime will be bound to the layout, and whenever the layout dies the child will be deleted automatically. One should use elm_layout_table_unpack to make this layout forget about the object.

If `colspan` or `rowspan` are bigger than 1, that object will occupy more space than a single cell.

See also elm_layout_table_unpack, elm_layout_table_clear.

Parameters

  [in] | child | The child object to pack into table.
  [in] | col | The column to which the child should be added. (>= 0)
  [in] | row | The row to which the child should be added. (>= 0)
  [in] | colspan | How many columns should be used to store this object. (>= 1)
  [in] | rowspan | How many rows should be used to store this object. (>= 1)

## elm_layout_table_unpack()

Evas_Object * elm_layout_table_unpack | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child )

Unpack (remove) a child of the given part table.

The object will be unpacked from the table part and its lifetime will not be handled by the layout anymore. This is equivalent to elm_layout_content_unset for table.

Parameters

  [in] | child | The object to remove from table.

Returns
  The object that was being used, or `null` if not found.

## elm_layout_table_clear()

Eina_Bool elm_layout_table_clear | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | clear )

Remove all the child objects of the given part table.

The objects will be removed from the table part and their lifetime will not be handled by the layout anymore. This is equivalent to elm_layout_table_unpack for all table children.

Parameters

  [in] | clear | If true, then all objects will be deleted as well, otherwise they will just be removed and will be dangling on the canvas.

## elm_layout_data_get()

const char * elm_layout_data_get | ( | const Evas_Object * | obj,
|  | const char * | key )

Get the edje data from the given layout.

This function fetches data specified inside the edje theme of this layout. This function return NULL if data is not found.

In EDC this comes from a data block within the group block that `obj` was loaded from.

Parameters

  [in] | key | The data key.

Returns
  The edje data string.

## elm_layout_freeze()

int elm_layout_freeze | ( | Evas_Object * | obj | ) |

Freezes the Elementary layout object.

This function puts all changes on hold. Successive freezes will nest, requiring an equal number of thaws.

See also elm_layout_thaw.

Returns
  The frozen state or 0 on error.

## elm_layout_thaw()

int elm_layout_thaw | ( | Evas_Object * | obj | ) |

Thaws the Elementary object.

This function thaws the given Edje object and the Elementary sizing calc.

Note
  If successive freezings were done, an equal number of thaws will be required.

See also elm_layout_freeze.

Returns
  The frozen state or 0 if the object is not frozen or on error.

## elm_layout_text_set()

Eina_Bool elm_layout_text_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | text )

Set the text of the given part.

Parameters

  [in] | part | The TEXT part where to set the text.
  [in] | text | The text to set.

Returns
  `true` on success, `false` otherwise

References EINA_FALSE, and EINA_TRUE.

## elm_layout_text_get()

const char * elm_layout_text_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Get the text set in the given part.

Parameters

  [in] | part | The TEXT part where to set the text.

Returns
  The text to set.

References EINA_TRUE.

## elm_layout_edje_object_can_access_set()

Eina_Bool elm_layout_edje_object_can_access_set | ( | Evas_Object * | obj,
|  | Eina_Bool | can_access )

Set accessibility to all texblock(text) parts in the layout object.

Parameters

  [in] | can_access | Makes all textblock(text) parts in the layout `obj` possible to have accessibility. `true` means textblock(text) parts can be accessible.

Returns
  `true` on success or `false` on failure. If `obj` is not a proper layout object, `false` is returned.

Since
  1.7

References _Efl_Ui_Layout_Data::can_access, EINA_FALSE, EINA_SAFETY_ON_NULL_RETURN_VAL, and EINA_TRUE.

## elm_layout_edje_object_can_access_get()

Eina_Bool elm_layout_edje_object_can_access_get | ( | const Evas_Object * | obj | ) |

Get accessibility state of texblock(text) parts in the layout object.

Returns
  Makes all textblock(text) parts in the layout `obj` possible to have accessibility. `true` means textblock(text) parts can be accessible.

Since
  1.7

References _Efl_Ui_Layout_Data::can_access, EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.

## elm_layout_part_cursor_engine_only_set()

Eina_Bool elm_layout_part_cursor_engine_only_set | ( | Evas_Object * | obj,
|  | const char * | part_name,
|  | Eina_Bool | engine_only )

Sets if the cursor set should be searched on the theme or should use the provided by the engine, only.

Note
  Before you set if should look on theme you should define a cursor with elm_layout_part_cursor_set. By default it will only look for cursors provided by the engine.

Parameters

  [in] | part_name | A part from loaded edje group.
  [in] | engine_only | If cursors should be just provided by the engine ($true) or should also search on widget's theme as well ($false)

Returns
  `true` on success or `false` on failure, that may be part not exists or it did not had a cursor set.

References EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.

## elm_layout_part_cursor_engine_only_get()

Eina_Bool elm_layout_part_cursor_engine_only_get | ( | const Evas_Object * | obj,
|  | const char * | part_name )

Get a specific cursor engine_only for an edje part.

Parameters

  [in] | part_name | A part from loaded edje group.

Returns
  Whenever the cursor is just provided by engine or also from theme.

References EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.

## elm_layout_part_cursor_set()

Eina_Bool elm_layout_part_cursor_set | ( | Evas_Object * | obj,
|  | const char * | part_name,
|  | const char * | cursor )

Sets a specific cursor for an edje part.

Parameters

  [in] | part_name | A part from loaded edje group.
  [in] | cursor | Cursor name to use, see Elementary_Cursor.h.

Returns
  `true` on success or `false` on failure, that may be part not exists or it has "mouse_events: 0".

References EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.

## elm_layout_part_cursor_get()

const char * elm_layout_part_cursor_get | ( | const Evas_Object * | obj,
|  | const char * | part_name )

Get the cursor to be shown when mouse is over an edje part.

Parameters

  [in] | part_name | A part from loaded edje group.

Returns
  Cursor name

References EINA_SAFETY_ON_NULL_RETURN_VAL.

## elm_layout_part_cursor_style_set()

Eina_Bool elm_layout_part_cursor_style_set | ( | Evas_Object * | obj,
|  | const char * | part_name,
|  | const char * | style )

Sets a specific cursor style for an edje part.

Parameters

  [in] | part_name | A part from loaded edje group.
  [in] | style | The theme style to use (default, transparent, ...).

Returns
  `true` on success or `false` on failure, that may be part not exists or it did not had a cursor set.

References EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.

## elm_layout_part_cursor_style_get()

const char * elm_layout_part_cursor_style_get | ( | const Evas_Object * | obj,
|  | const char * | part_name )

Get a specific cursor style for an edje part.

Parameters

  [in] | part_name | A part from loaded edje group.

Returns
  The theme style in use, defaults to "default". If the object does not have a cursor set, then `null` is returned.

References EINA_SAFETY_ON_NULL_RETURN_VAL.

## elm_layout_part_cursor_unset()

Eina_Bool elm_layout_part_cursor_unset | ( | Evas_Object * | obj,
|  | const char * | part_name )

Unsets a cursor previously set with elm_layout_part_cursor_set.

Parameters

  [in] | part_name | A part from loaded edje group, that had a cursor set wit elm_layout_part_cursor_set.

Returns
  `true` on success, `false` otherwise

References EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.